// gs2mbDlg.cpp : implementation file
//

#include "stdafx.h"
#include "gs2mb.h"
#include "gs2mbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGs2mbDlg dialog

CGs2mbDlg::CGs2mbDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGs2mbDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGs2mbDlg)
	m_szNewGS = _T("");
	m_szNewMB = _T("");
	m_szOldGS = _T("");
	m_szOldMB = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGs2mbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGs2mbDlg)
	DDX_Text(pDX, IDC_NEWGS, m_szNewGS);
	DDX_Text(pDX, IDC_NEWMB, m_szNewMB);
	DDX_Text(pDX, IDC_OLDGS, m_szOldGS);
	DDX_Text(pDX, IDC_OLDMB, m_szOldMB);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGs2mbDlg, CDialog)
	//{{AFX_MSG_MAP(CGs2mbDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GS2MB, OnGs2mb)
	ON_BN_CLICKED(IDC_MB2GS, OnMb2gs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGs2mbDlg message handlers

BOOL CGs2mbDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	//return TRUE;  // return TRUE  unless you set the focus to a control
	return FALSE;
}

void CGs2mbDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGs2mbDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGs2mbDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGs2mbDlg::OnGs2mb() 
{
	CString sz;
	char szValue[3], szAddr[5], szPrelim[9];
	INT nValue, nAddr, nParity;
	UpdateData(TRUE);
	sz = ToUpper(m_szOldGS);
	if (sz.GetLength() != 8 || ! VerifyGSDigits(sz)) {
		MessageBox("Invalid GameShark code");
		return;
	}
	strncpy(szValue, sz.Mid(2, 2), 2);
	szValue[2] = '\0';
	strncpy(szAddr, sz.Mid(6, 2), 2);
	strncpy(szAddr + 2, sz.Mid(4, 2), 2);
	szAddr[4] = '\0';

	sscanf(szValue, "%x", &nValue);
	nValue &= 0xFF;
	sscanf(szAddr, "%x", &nAddr);
	nAddr &= 0xFFFF;
	nAddr = (nAddr - 0x3198) & 0xFFFF;
	nParity = (0xFF - nValue - ((nAddr >> 8) & 0xFF) - (nAddr & 0xFF)) & 0xFF;

	sprintf(szPrelim, "%2.2X%4.4X%2.2X", nParity, nAddr, nValue);
	m_szNewMB = TranslateToUgly(szPrelim);

	UpdateData(FALSE);
}

void CGs2mbDlg::OnMb2gs() 
{
	CString sz;
	char szValue[3], szAddr[5], szParity[3], szFinal[9];
	INT nValue, nAddr, nParity, nChecksum;
	UpdateData(TRUE);
	sz = ToUpper(m_szOldMB);
	if (sz.GetLength() != 8 || ! VerifyMBDigits(sz)) {
		MessageBox("Invalid Monster Brain code");
		return;
	}
	sz = TranslateFromUgly(sz);

	strncpy(szValue, sz.Mid(6, 2), 2);
	szValue[2] = '\0';
	strncpy(szAddr, sz.Mid(2, 4), 4);
	szAddr[4] = '\0';
	strncpy(szParity, sz.Left(2), 2);
	szParity[2] = '\0';

	sscanf(szValue, "%x", &nValue);
	nValue &= 0xFF;
	sscanf(szAddr, "%x", &nAddr);
	nAddr &= 0xFFFF;
	sscanf(szParity, "%x", &nParity);
	nParity &= 0xFF;

	nChecksum = (nValue + ((nAddr >> 8) & 0xFF) + (nAddr & 0xFF) + nParity) & 0xFF;
	nAddr = (nAddr + 0x3198) & 0xFFFF;
	
	if (nChecksum != 0xFF) {
		MessageBox("Warning: Monster Brain checksum doesn't match up.");
	}
	
	sprintf(szFinal, "01%2.2X%2.2X%2.2X", nValue, (nAddr & 0xFF), ((nAddr >> 8) & 0xFF));
	m_szNewGS = szFinal;

	UpdateData(FALSE);
}

BOOL CGs2mbDlg::VerifyGSDigits(const CString &sz)
{
	for (int i = 0; i < sz.GetLength(); i += 1) {
		switch(sz.GetAt(i)) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
				break;
			default:
				return FALSE;
		}
	}
	return TRUE;
}

CString CGs2mbDlg::ToUpper(const CString &sz)
{
	CString szNew = sz;
	for (int i = 0; i < szNew.GetLength(); i += 1) {
		szNew.SetAt(i, toupper(szNew.GetAt(i)));
	}
	return szNew;
}

CString CGs2mbDlg::TranslateToUgly(const CString &sz)
{
	CString szNew = sz;
	for (int i = 0; i < sz.GetLength(); i += 1) {
		switch(sz.GetAt(i)) {
			case '0': szNew.SetAt(i, 'A'); break;
			case '1': szNew.SetAt(i, 'C'); break;
			case '2': szNew.SetAt(i, 'D'); break;
			case '3': szNew.SetAt(i, 'E'); break;
			case '4': szNew.SetAt(i, 'F'); break;
			case '5': szNew.SetAt(i, 'H'); break;
			case '6': szNew.SetAt(i, 'I'); break;
			case '7': szNew.SetAt(i, 'K'); break;
			case '8': szNew.SetAt(i, 'L'); break;
			case '9': szNew.SetAt(i, 'M'); break;
			case 'A': szNew.SetAt(i, 'N'); break;
			case 'B': szNew.SetAt(i, 'O'); break;
			case 'C': szNew.SetAt(i, 'R'); break;
			case 'D': szNew.SetAt(i, 'S'); break;
			case 'E': szNew.SetAt(i, 'T'); break;
			case 'F': szNew.SetAt(i, 'U'); break;
				break;
			default:
				ASSERT(FALSE);
		}
	}
	return szNew;
}

BOOL CGs2mbDlg::VerifyMBDigits(const CString &sz)
{
	for (int i = 0; i < sz.GetLength(); i += 1) {
		switch(sz.GetAt(i)) {
			case 'A':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'H':
			case 'I':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'O':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
				break;
			default:
				return FALSE;
		}
	}
	return TRUE;
}

CString CGs2mbDlg::TranslateFromUgly(const CString &sz)
{
	CString szNew = sz;
	for (int i = 0; i < sz.GetLength(); i += 1) {
		switch(sz.GetAt(i)) {
			case 'A': szNew.SetAt(i, '0'); break;
			case 'C': szNew.SetAt(i, '1'); break;
			case 'D': szNew.SetAt(i, '2'); break;
			case 'E': szNew.SetAt(i, '3'); break;
			case 'F': szNew.SetAt(i, '4'); break;
			case 'H': szNew.SetAt(i, '5'); break;
			case 'I': szNew.SetAt(i, '6'); break;
			case 'K': szNew.SetAt(i, '7'); break;
			case 'L': szNew.SetAt(i, '8'); break;
			case 'M': szNew.SetAt(i, '9'); break;
			case 'N': szNew.SetAt(i, 'A'); break;
			case 'O': szNew.SetAt(i, 'B'); break;
			case 'R': szNew.SetAt(i, 'C'); break;
			case 'S': szNew.SetAt(i, 'D'); break;
			case 'T': szNew.SetAt(i, 'E'); break;
			case 'U': szNew.SetAt(i, 'F'); break;
				break;
			default:
				ASSERT(FALSE);
		}
	}
	return szNew;
}
