// gs2mbDlg.h : header file
//

#if !defined(AFX_GS2MBDLG_H__EC1AC3DA_D52F_4AAA_81FE_A43E7F9B91DC__INCLUDED_)
#define AFX_GS2MBDLG_H__EC1AC3DA_D52F_4AAA_81FE_A43E7F9B91DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CGs2mbDlg dialog

class CGs2mbDlg : public CDialog
{
// Construction
public:
	CGs2mbDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CGs2mbDlg)
	enum { IDD = IDD_GS2MB_DIALOG };
	CString	m_szNewGS;
	CString	m_szNewMB;
	CString	m_szOldGS;
	CString	m_szOldMB;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGs2mbDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CGs2mbDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnGs2mb();
	afx_msg void OnMb2gs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	static CString TranslateFromUgly(const CString& sz);
	static BOOL VerifyMBDigits(const CString& sz);
	static CString TranslateToUgly(const CString& sz);
	static CString ToUpper(const CString& sz);
	static BOOL VerifyGSDigits(const CString& sz);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GS2MBDLG_H__EC1AC3DA_D52F_4AAA_81FE_A43E7F9B91DC__INCLUDED_)
